unit KOLSPCDriveComboBox;

interface
uses
  Windows, Messages, KOL, KOLSPCDirectoryListBox;

type

  PSPCDriveCombo =^TSPCDriveCombo;
  TSPCDriveComboBox = PSPCDriveCombo;
  TSPCDriveCombo = object(TObj)
  private
    { Private declarations }
    fColor: TColor;
    fIntegralHeight: Boolean;
    fInitialized: Integer;
    fCurIndex: Integer;
    fControl : PControl;
    fDrive: char;
    fFont: PGraphicTool;
    fLVBkColor: Integer;
    fOnChange: TOnEvent;
    fAOwner: PControl;
    fDirectoryList: TSPCDirectoryListBox;
    procedure LVPaint;
    procedure SetDrive(Value: char);
    procedure BuildList;
    procedure DoChange(Obj: PObj);
  protected
    { Protected declarations }
  public
    destructor Destroy; virtual;
    function SetAlign(Value: TControlAlign): PSPCDriveCombo; overload;
    function SetPosition(X, Y: integer): PSPCDriveCombo; overload;
    function SetSize(X, Y: integer): PSPCDriveCombo; overload;
    function GetFont: PGraphicTool;
    property Color: TColor read fColor write fColor;
    property DirectoryList: TSPCDirectoryListBox read fDirectoryList write fDirectoryList;
    { Public declarations }
    property Font: PGraphicTool read GetFont;
    property IntegralHeight: Boolean read fIntegralHeight write fIntegralHeight;
    property Drive: char read fDrive write SetDrive;
    property CurIndex: Integer read fCurIndex write fCurIndex;
    property LVBkColor: Integer read fLVBkColor write fLVBkColor;
    property OnChange: TOnEvent read fOnChange write fOnChange;
  end;

function NewTSPCDriveComboBox(AOwner: PControl; Options: TComboOptions): PSPCDriveCombo;
function CheckBit(Value,Index: LongInt): Boolean;

var
  fDriveName: array[0..25]of char=('A','B','C','D','E','F','G','H','I','J','K',
                                   'L','M','N','O','P','Q','R','S','T','U','V',
                                   'W','X','Y','Z');
implementation

uses objects;

function CheckBit;
var
  fL: LongInt;
begin
  fL:=Value;
  fL:=fL shr Index;
  fL:=fL and $01;
  if fL=1 then Result:=True else Result:=False;
end;

function NewTSPCDriveComboBox;
var p: PSPCDriveCombo;
    c: PControl;
begin
   c:=NewComboBox(AOwner,[coReadOnly]);
   New(p,create);
   AOwner.Add2AutoFree(p);
   p.fControl:= c;
   p.fControl.Font.FontHeight:=-11;
   p.fIntegralHeight:=True;
   p.fFont:=NewFont;
   p.fAOwner:=AOwner;
   p.fControl.OnChange:=p.DoChange;
   p.BuildList;
   p.fInitialized:=0;
   Result:=p;
end;

procedure TSPCDriveCombo.DoChange(Obj: PObj);
begin
  Drive:=fControl.Items[fControl.CurIndex][1];
  if Assigned(fOnChange) then fOnChange(@Self);
end;

destructor TSPCDriveCombo.Destroy;
begin
   fFont.Free;
   inherited;
end;

function TSPCDriveCombo.SetAlign(Value: TControlAlign): PSPCDriveCombo;
begin
  fControl.Align:=Value;
  Result:=@Self;
end;

function TSPCDriveCombo.SetPosition(X, Y: integer): PSPCDriveCombo;
begin
   fControl.Left := X;
   fControl.Top := Y;
   Result := @self;
end;

function TSPCDriveCombo.SetSize(X, Y: integer): PSPCDriveCombo;
begin
   fControl.Width  := X;
   fControl.Height := Y;
   Result := @self;
end;

function TSPCDriveCombo.GetFont;
begin
   Result := fFont;
end;

procedure TSPCDriveCombo.LVPaint;
begin
  fControl.Font.Assign(Font);
end;

procedure TSPCDriveCombo.SetDrive;
var
  fC: Char;
  i: LongInt;
begin
  fControl.Font.Assign(fFont);
  fControl.Color:=fColor;
  fC:=Value;
  if fControl.SearchFor(fc,0,True)>-1 then
  begin
    fDrive:=fC;
    fControl.CurIndex:=fControl.SearchFor(fc,0,True);
  end;
  Inc(fInitialized);
  if fInitialized>2 then fInitialized:=2;
  if fInitialized=2 then
  begin
    if Assigned(DirectoryList) then DirectoryList.Path:=Drive;
  end;
  if Assigned(fOnChange) then if fInitialized=2 then fOnChange(@Self);
end;

procedure TSPCDriveCombo.BuildList;
var
  fFlags: LongInt;
  i: LongInt;
  fDir: string;
  fMaximumComponentLength: Cardinal;
  fVolumeName: PChar;
  fVolumeNameLength: Cardinal;
  fDriveType: string;
  fFullPath: string;
begin
  GetDir(0,fDir);
  fControl.Clear;
  fFlags:=GetLogicalDrives;
  for i:=0 to 25 do if CheckBit(fFlags,i) then
  begin
    fFullPath:=fDriveName[i]+':';
    case GetDriveType(PChar(fFullPath)) of
    0:fDriveType:=' ';
    1:fDriveType:=' ';
    2:fDriveType:=' ';
    3:fDriveType:=' ';
    4:fDriveType:=' ';
    5:fDriveType:='CD';
    end;
    fControl.Add(fDriveName[i]+' - ['+fDriveType+']');
  end;
  fControl.CurIndex:=fControl.SearchFor(fDir[1],0,True);
end;

end.
