unit mckSPCDirectoryEditBox;

interface
{$R *.res}
uses
  Windows, Messages, mirror, classes, kol, mckCtrls, KOLSPCCustomFunctions;

type

  TSPCDirectoryEditBox = class(TKOLScrollBox)
  private
    { Private declarations }
    fPath: string;
    fCaptionEmpty: string;
    fTitle: string;
    fOnDirChanged: TOnEvent;
    fNotAvailable: Boolean;
    function AdditionalUnits: string; override;
    procedure SetTitle(Value: string);
    procedure SetCaptionEmpty(Value: string);
    procedure SetPath(Value: string);
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(Owner: TComponent); override;
  published
    { Published declarations }
    property Path: string read fPath write SetPath;
    property Title: string read fTitle write SetTitle;
    property OnDirChanged: TOnEvent read fOnDirChanged write fOnDirChanged;
    property Font;
    property CaptionEmpty: string read fCaptionEmpty write SetCaptionEmpty;
    property OnChange: Boolean read FNotAvailable;
    property OnShow: Boolean read FNotAvailable;
    property OnScroll: Boolean read FNotAvailable;
    property OnResize: Boolean read FNotAvailable;
    property OnPaint: Boolean read FNotAvailable;
    property OnMove: Boolean read FNotAvailable;
    property OnMouseWheel: Boolean read FNotAvailable;
    property OnMouseUp: Boolean read FNotAvailable;
    property OnMouseMove: Boolean read FNotAvailable;
    property OnMouseLeave: Boolean read FNotAvailable;
    property OnMouseEnter: Boolean read FNotAvailable;
    property OnMouseDown: Boolean read FNotAvailable;
    property OnMouseDblClk: Boolean read FNotAvailable;
    property OnMessage: Boolean read FNotAvailable;
    property OnHide: Boolean read FNotAvailable;
    property OnEraseBkgnd: Boolean read FNotAvailable;
    property OnDropFiles: Boolean read FNotAvailable;
    property OnDestroy: Boolean read FNotAvailable;
    property OnClick: Boolean read FNotAvailable;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('KOLSPCUtil', [TSPCDirectoryEditBox]);
end;

constructor TSPCDirectoryEditBox.Create;
var
  TS: string;
begin
   inherited;
   Width:=145;
   Height:=21;
   Title:='Select folder:';
   GetDir(0,TS);
   Path:=TS;
end;

function  TSPCDirectoryEditBox.AdditionalUnits;
begin
   Result := ', KOLSPCDirectoryEditBox';
end;

procedure TSPCDirectoryEditBox.SetPath(Value: string);
begin
  if DirectoryExists(Value) then fPath:=Value else fPath:='';
  Change;
end;

procedure TSPCDirectoryEditBox.SetCaptionEmpty(Value: string);
begin
  fCaptionEmpty:=Value;
  Change;
end;

procedure TSPCDirectoryEditBox.SetTitle(Value: string);
begin
  fTitle:=Value;
  Change;
end;

procedure TSPCDirectoryEditBox.SetupFirst;
begin
   inherited;
   SL.Add(Prefix+AName+'.Color:='+Int2Str(Color)+';');
   SL.Add(Prefix+AName+'.Title:='''+Title+''';');
   SL.Add(Prefix+AName+'.CaptionEmpty:='''+CaptionEmpty+''';');
   SL.Add(Prefix+AName+'.Initialize;');
   SL.Add(Prefix+AName+'.Path:='''+Path+''';');
   if Assigned(fOnDirChanged) then SL.Add(Prefix+AName+'.OnDirChanged:='+'Result.'+Name+'DirChanged;');
end;

end.
