unit mckSPCDirectoryListBox;

interface
{$R *.res}
uses
  Windows, Messages, mirror, classes, kol, mckCtrls, KOLSPCCustomFunctions, mckSPCFileListBox;

type

  TSPCDirectoryListBox = class(TKOLListView)
  private
    { Private declarations }
    fIntegralHeight: Boolean;
    fDoIndent: Boolean;
    fPath: string;
    FNotAvailable: Boolean;
    function  AdditionalUnits: string; override;
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
    procedure SetPath(Value: string);
    procedure SetIndent(Value: Boolean);
    procedure SetIntegralHeight(Value: Boolean);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(Owner: TComponent); override;
  published
    { Published declarations }
    property Items: Boolean read FNotAvailable;
    property ImageListState: Boolean read FNotAvailable;
    property ImageListSmall: Boolean read FNotAvailable;
    property ImageListNormal: Boolean read FNotAvailable;
    property Path: string read fPath write SetPath;
    property IntegralHeight: Boolean read fIntegralHeight write SetIntegralHeight;
    property DoIndent: Boolean read fDoIndent write SetIndent;
    property OnChange: Boolean read FNotAvailable;
    property OnShow: Boolean read FNotAvailable;
    property OnResize: Boolean read FNotAvailable;
    property OnPaint: Boolean read FNotAvailable;
    property OnMove: Boolean read FNotAvailable;
    property OnMouseWheel: Boolean read FNotAvailable;
    property OnMouseUp: Boolean read FNotAvailable;
    property OnMouseMove: Boolean read FNotAvailable;
    property OnMouseLeave: Boolean read FNotAvailable;
    property OnMouseEnter: Boolean read FNotAvailable;
    property OnMouseDown: Boolean read FNotAvailable;
    property OnMessage: Boolean read FNotAvailable;
    property OnMeasureItem: Boolean read FNotAvailable;
    property OnLeave: Boolean read FNotAvailable;
    property OnKeyUp: Boolean read FNotAvailable;
    property OnKeyDown: Boolean read FNotAvailable;
    property OnHide: Boolean read FNotAvailable;
    property OnEnter: Boolean read FNotAvailable;
    property OnDropFiles: Boolean read FNotAvailable;
    property OnDropDown: Boolean read FNotAvailable;
    property OnDrawItem: Boolean read FNotAvailable;
    property OnDestroy: Boolean read FNotAvailable;
    property OnEraseBkgnd: Boolean read FNotAvailable;
    property OnCloseUp: Boolean read FNotAvailable;
    property OnClick: Boolean read FNotAvailable;
    property OnChar: Boolean read FNotAvailable;
    property OnScroll: Boolean read FNotAvailable;
    property OnLVStateChange: Boolean read FNotAvailable;
    property OnLVData: Boolean read FNotAvailable;
    property OnEndEditLVItem: Boolean read FNotAvailable;
    property OnDeleteLVItem: Boolean read FNotAvailable;
    property OnDeleteAllLVItems: Boolean read FNotAvailable;
    property OnCompareLVItems: Boolean read FNotAvailable;
    property OnColumnClick: Boolean read FNotAvailable;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('KOLSPCUtil', [TSPCDirectoryListBox]);
end;

procedure TSPCDirectoryListBox.SetIndent(Value: Boolean);
begin
  fDoIndent:=Value;
  Change;
end;

constructor TSPCDirectoryListBox.Create;
var
  TS: string;
begin
   inherited;
   Width:=145;
   Height:=105;
   DoIndent:=True;
   GetDir(0,TS);
   Path:=TS;
end;

function  TSPCDirectoryListBox.AdditionalUnits;
begin
   Result := ', KOLSPCDirectoryListBox';
end;

procedure TSPCDirectoryListBox.SetupFirst;
var St: string;
begin
   inherited;
   SL.Add( Prefix + AName + '.DoIndent:='+Boolean2Str(DoIndent)+';');
   SL.Add( Prefix + AName + '.Path:='''+Path+''';');
   SL.Add( Prefix + AName + '.IntegralHeight:='+Boolean2Str(IntegralHeight)+';');
end;

procedure TSPCDirectoryListBox.SetIntegralHeight(Value: Boolean);
begin
  fIntegralHeight:=Value;
  Change;
end;

procedure TSPCDirectoryListBox.SetPath(Value: string);
var
  fT: string;
begin
  fT:=Value;
  if Value[Length(Value)]='\' then fT:=Value else
  if Length(Value)=1 then fT:=Value+':\' else fT:=Value+'\';
  if DirectoryExists(fT) then fPath:=fT else fPath:='';
  Change;
end;

end.
