unit mckSPCDriveComboBox;
{$R *.res}
interface

uses
  Windows, Messages, mirror, classes, Controls, Forms, kol, mckCtrls, mckSPCDirectoryListBox;

type

  TSPCDriveComboBox = class(TKOLComboBox)
  private
    { Private declarations }
    fDrive: char;
    FNotAvailable: Boolean;
    fDirectoryList: TSPCDirectoryListBox;
    function  AdditionalUnits: string; override;
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
    procedure SetDrive(Value: char);
    procedure SetDirectoryList(Value: TSPCDirectoryListBox);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(Owner: TComponent); override;
  published
    { Published declarations }
    property DirList: TSPCDirectoryListBox read fDirectoryList write SetDirectoryList;
    property Drive: char read fDrive write SetDrive;
    property OnSelChange: Boolean read FNotAvailable;
    property OnShow: Boolean read FNotAvailable;
    property OnResize: Boolean read FNotAvailable;
    property OnPaint: Boolean read FNotAvailable;
    property OnMove: Boolean read FNotAvailable;
    property OnMouseWheel: Boolean read FNotAvailable;
    property OnMouseUp: Boolean read FNotAvailable;
    property OnMouseMove: Boolean read FNotAvailable;
    property OnMouseLeave: Boolean read FNotAvailable;
    property OnMouseEnter: Boolean read FNotAvailable;
    property OnMouseDown: Boolean read FNotAvailable;
    property OnMOuseDblClk: Boolean read FNotAvailable;
    property OnMessage: Boolean read FNotAvailable;
    property OnMeasureItem: Boolean read FNotAvailable;
    property OnLeave: Boolean read FNotAvailable;
    property OnKeyUp: Boolean read FNotAvailable;
    property OnKeyDown: Boolean read FNotAvailable;
    property OnHide: Boolean read FNotAvailable;
    property OnEnter: Boolean read FNotAvailable;
    property OnDropFiles: Boolean read FNotAvailable;
    property OnDropDown: Boolean read FNotAvailable;
    property OnDrawItem: Boolean read FNotAvailable;
    property OnDestroy: Boolean read FNotAvailable;
    property OnEraseBkgnd: Boolean read FNotAvailable;
    property OnCloseUp: Boolean read FNotAvailable;
    property OnClick: Boolean read FNotAvailable;
    property OnChar: Boolean read FNotAvailable;
    property Items: Boolean read FNotAvailable;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('KOLSPCUtil', [TSPCDriveComboBox]);
end;

constructor TSPCDriveComboBox.Create;
var
  TS: string;
begin
   inherited;
   Width:=145;
   Height:=19;
   Color:=clWhite;
   GetDir(0,TS);
   Drive:=TS[1];
end;

function TSPCDriveComboBox.AdditionalUnits;
begin
   Result := ', KOLSPCDriveComboBox';
end;

procedure TSPCDriveComboBox.SetupFirst;
var St: string;
begin
   inherited;
   SL.Add( Prefix + AName + '.Color:='+Int2Str(Color)+';');
   SL.Add( Prefix + AName + '.Drive:='''+Drive+''';');
   if Assigned(fDirectoryList) then SL.Add( Prefix + AName + '.DirectoryList:=Result.'+DirList.Name+';');
end;

procedure TSPCDriveComboBox.SetDrive;
var
  fC: Char;
begin
  fC:=Value;
  if DirectoryExists(fC+':') then
  begin
    fDrive:=Value;
  end;
  Change;
end;

procedure TSPCDriveComboBox.SetDirectoryList(Value: TSPCDirectoryListBox);
begin
  fDirectoryList:=Value;
  Change;
end;

end.
