unit mckSPCFileListBox;

interface
{$R *.res}
uses
  Windows, Messages, classes, kol, mckCtrls, KOLSPCCustomFunctions;

type

  TSPCFileListBox = class;

  TSPCFileListBox = class(TKOLListBox)
  private
    { Private declarations }
    fIntegralHeight: Boolean;
    fDoCase: TCase;
    fPath: string;
    fMask: string;
    FNotAvailable: Boolean;
    function  AdditionalUnits: string; override;
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
    procedure SetPath(Value: string);
    procedure SetMask(Value: string);
    procedure SetIntegralHeight(Value: Boolean);
    procedure SetCase(Value: TCase);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(Owner: TComponent); override;
  published
    { Published declarations }
    property Path: string read fPath write SetPath;
    property Mask: string read fMask write SetMask;
    property DoCase: TCase read fDoCase write SetCase;
    property IntegralHeight: Boolean read fIntegralHeight write SetIntegralHeight;
    property OnChange: Boolean read FNotAvailable;
    property OnShow: Boolean read FNotAvailable;
    property OnResize: Boolean read FNotAvailable;
    property OnPaint: Boolean read FNotAvailable;
    property OnMove: Boolean read FNotAvailable;
    property OnMouseWheel: Boolean read FNotAvailable;
    property OnMouseUp: Boolean read FNotAvailable;
    property OnMouseMove: Boolean read FNotAvailable;
    property OnMouseLeave: Boolean read FNotAvailable;
    property OnMouseEnter: Boolean read FNotAvailable;
    property OnMouseDown: Boolean read FNotAvailable;
    property OnMOuseDblClk: Boolean read FNotAvailable;
    property OnMessage: Boolean read FNotAvailable;
    property OnMeasureItem: Boolean read FNotAvailable;
    property OnLeave: Boolean read FNotAvailable;
    property OnKeyUp: Boolean read FNotAvailable;
    property OnKeyDown: Boolean read FNotAvailable;
    property OnHide: Boolean read FNotAvailable;
    property OnEnter: Boolean read FNotAvailable;
    property OnDropFiles: Boolean read FNotAvailable;
    property OnDropDown: Boolean read FNotAvailable;
    property OnDrawItem: Boolean read FNotAvailable;
    property OnDestroy: Boolean read FNotAvailable;
    property OnEraseBkgnd: Boolean read FNotAvailable;
    property OnCloseUp: Boolean read FNotAvailable;
    property OnClick: Boolean read FNotAvailable;
    property OnChar: Boolean read FNotAvailable;
    property OnScroll: Boolean read FNotAvailable;
//    property Items: Boolean read FNotAvailable;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('KOLSPCUtil', [TSPCFileListBox]);
end;

constructor TSPCFileListBox.Create;
var
  TS: string;
begin
   inherited;
   Width:=145;
   Height:=105;
   Mask:='*.*';
   DoCase:=ctLower;
   GetDir(0,TS);
   Path:=TS;
end;

function  TSPCFileListBox.AdditionalUnits;
begin
   Result := ', KOLSPCFileListBox';
end;

procedure TSPCFileListBox.SetupFirst;
var St: string;
begin
   inherited;
   case DoCase of
   ctDefault:St:='0';
   ctLower:St:='1';
   ctUpper:St:='2';
   end;
   SL.Add(Prefix+AName+'.DoCase:='+St+';');
   SL.Add( Prefix + AName + '.IntegralHeight:='+Boolean2Str(IntegralHeight)+';');
   SL.Add( Prefix + AName + '.Mask:='''+Mask+''';');
   SL.Add( Prefix + AName + '.Color:='+Int2Str(Color)+';');
   SL.Add( Prefix + AName + '.Path:='''+Path+''';');
end;

procedure TSPCFileListBox.SetCase(Value: TCase);
begin
  fDoCase:=Value;
  Change;
end;

procedure TSPCFileListBox.SetIntegralHeight(Value: Boolean);
begin
  fIntegralHeight:=Value;
  Change;
end;

procedure TSPCFileListBox.SetMask(Value: string);
begin
  fMask:=Value;
  Change;
end;

procedure TSPCFileListBox.SetPath(Value: string);
begin
  if DirectoryExists(Value) then
  begin
    if Value[Length(Value)]='\' then fPath:=Value else fPath:=Value+'\';
  end else fPath:='';
  Change;
end;

end.
