unit mckSPCFilterComboBox;
{$R *.res}
interface

uses
  Windows, Messages, mirror, classes, Controls, Forms, kol, mckCtrls;

type

  TSPCFilterComboBox = class(TKOLComboBox)
  private
    { Private declarations }
    fLines: TStrings;
    FNotAvailable: Boolean;
    function  AdditionalUnits: string; override;
    procedure SetText(Value: TStrings);
    function GetText: TStrings;
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(Owner: TComponent); override;
  published
    { Published declarations }
    property Items: Boolean read FNotAvailable;
    property Filters: TStrings read GetText write SetText;
    property OnSelChange: Boolean read FNotAvailable;
    property OnShow: Boolean read FNotAvailable;
    property OnResize: Boolean read FNotAvailable;
    property OnPaint: Boolean read FNotAvailable;
    property OnMove: Boolean read FNotAvailable;
    property OnMouseWheel: Boolean read FNotAvailable;
    property OnMouseUp: Boolean read FNotAvailable;
    property OnMouseMove: Boolean read FNotAvailable;
    property OnMouseLeave: Boolean read FNotAvailable;
    property OnMouseEnter: Boolean read FNotAvailable;
    property OnMouseDown: Boolean read FNotAvailable;
    property OnMOuseDblClk: Boolean read FNotAvailable;
    property OnMessage: Boolean read FNotAvailable;
    property OnMeasureItem: Boolean read FNotAvailable;
    property OnLeave: Boolean read FNotAvailable;
    property OnKeyUp: Boolean read FNotAvailable;
    property OnKeyDown: Boolean read FNotAvailable;
    property OnHide: Boolean read FNotAvailable;
    property OnEnter: Boolean read FNotAvailable;
    property OnDropFiles: Boolean read FNotAvailable;
    property OnDropDown: Boolean read FNotAvailable;
    property OnDrawItem: Boolean read FNotAvailable;
    property OnDestroy: Boolean read FNotAvailable;
    property OnEraseBkgnd: Boolean read FNotAvailable;
    property OnCloseUp: Boolean read FNotAvailable;
    property OnClick: Boolean read FNotAvailable;
    property OnChar: Boolean read FNotAvailable;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('KOLSPCUtil', [TSPCFilterComboBox]);
end;

constructor TSPCFilterComboBox.Create;
var
  TS: string;
begin
   inherited;
   Width:=145;
   Height:=19;
   Color:=clWhite;
   fLines:=TStringList.Create;
end;

function  TSPCFilterComboBox.AdditionalUnits;
begin
   Result := ', KOLSPCFilterComboBox';
end;

procedure TSPCFilterComboBox.SetText;
begin
  fLines.Text:=Value.Text;
  Change;
end;

function TSPCFilterComboBox.GetText: TStrings;
begin
  Result:=fLines;
end;

procedure TSPCFilterComboBox.SetupFirst;
var
  i: Integer;
begin
   inherited;
   AddLongTextField(SL,Prefix+AName+'.Text:=',FLines.Text,';');
   SL.Add( Prefix + AName + '.Color:='+Int2Str(Color)+';');
   SL.Add( Prefix + AName + '.BuildList;');
end;

end.
